/*
 * @Author: your name
 * @Date: 2021-09-23 18:50:38
 * @LastEditTime: 2021-09-28 13:34:06
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Editd
 * @FilePath: /apollo-master/media/xnm/xnm/ros/RM/roadmodel/modules/common/road/local_view.h
 */

#pragma once

#include <memory>

// #include "mpc_drv_msgs/msg/road_info.hpp"
#include "BA_Enum_List.h"
// #include "mpc_drv_msgs/msg/control_waypoints.hpp"
#include "common_BA.h"
// #include "interface/rm_road_info.h"
// #include "interface/slam_decision.h"
#include "dpc/impl_type_roadinfo.h"
#include "dpc/impl_type_controlwaypoints.h"

// using namespace CEM_Msg_Demo;
namespace BA
{

  /**
 * @struct Input_BA
 * @brief Input_BA contains all necessary data as BA input
 */
  struct Input_BA
  {
    uint8_t RM_LaneLineCrossed;
    RoadInfo RM_RoadModel;
    DriveMd SM_DriveMode;
    float SM_DrvrSetSpd;
    SeldDistLvl SM_DrvrSetDstLvl;
    DircnIndSts SM_DirectionIndicatorSts;
    LFCmfrtAvlblBhvr SM_LFComfortAvlblBehavior;
    LCAvlblBhvr SM_LCAvlblBehavior;
    LCPAvlblBhvr SM_LCPAvlblBehavior;
    LongtAvlblBhvr SM_LongtAvlblBehavior;

    BA_ActionTyp BA_OptAction_LastCycle;
    uint32_t BA_OptCorridorID_LastCycle;
    uint32_t BA_OptTargetObjID_LastCycle;
	  uint8_t BA_OptLaneID_LastCycle;
    uint8_t BA_LCCls_LastCycle;
    uint8_t BA_LCPCls_LastCycle;
    bool BA_SpdLimitFlg_LastCycle;
    BA::SpdLmtTyp BA_SpdLimitType_LastCycle;
    uint8_t BA_SpdLimitID_LastCycle;

    float VSE_LongitudinalVelocity = 0.0;
    float VSE_LatAcc = 0.0;
    float VSE_LongtAcc = 0.0;
    float VSE_Yawrate = 0.0;

    uint8_t BA_TgtLaneStID_LastCycle;
    uint8_t BA_TgtLaneEndID_LastCycle;

    LatActvFuncSts SM_LatActvFunc;

    ControlWaypoints EHR_EHRInfo;
    BA::AutoLCAvlblSts SM_AutoLnChgAvlbl;
    BA::SignSpeedLimit SM_SignSpeedLimit01;  // the first nearest one
    BA::SignSpeedLimit SM_SignSpeedLimit02;  // the second nearest one

    DircnIndSts BA_DirectionIndicatorSts_LastCycle = BA::DircnIndSts_Off;
  };

} // namespace BA
